
/* client */

#include <fcntl.h>
#include <gtk/gtk.h>
#include <keybinder.h>

char talk_ch, popup, sync_play;
int per, interrupt, hot_num, talk_pressed;
GtkWidget *ww, *b1, *btns, *btn, *talk, *send_eight, *send_a, *send_v, *recv_a,
  *recv_v, *recv_eight, *recv_dither, *recv_2, *send_2;

#include "trunk_structs.h"
#include "avi_grabber.c"

static gboolean del (GtkWidget *w, GdkEvent *e, gpointer d) {
  fprintf(stderr, "event del\n");
  struct peer_stru *r = d;
  BOTH {
    if (r->w[i] == w) {
      r->d[i] = 0;
      r->w[i] = 0;
    }
  }
  return FALSE;
}

void uspawn (GtkWidget *w, struct peer_stru *t) {
  fprintf(stderr, "uspawn(): %i\n", t - u);
  i = 0;
  if (t->d[i]) i++;
  if (t->d[i]) return;
  t->w[i] = WNEW;
  t->d[i] = gtk_drawing_area_new();
  DSIZE(t->d[i], t->x, t->y);
  CADD(t->w[i], t->d[i]);
  g_signal_connect(t->w[i], "delete-event", G_CALLBACK(del), t);
  TITLE(t->w[i], t->stat);
  SALL(t->w[i]);
}


void video_out (struct peer_stru *r, struct b_stru *b) {
  if (r->popup) {
    uspawn(0, r);
    r->popup = 0;
  }
  if (!b->m) return;
  realloc_b(r->y * r->x * 3, b);
  GdkPixbuf *p = gdk_pixbuf_new_from_data((unsigned char *) b->b, GDK_COLORSPACE_RGB,
    0, 8, r->x, r->y, r->x * 3, 0, 0);
  BOTH { /* draw image on window */
    GtkWidget *wi = r->d[i];
    if (!wi) continue;
    GdkPixbuf *ps = gdk_pixbuf_scale_simple(p, wi->allocation.width,
      wi->allocation.height, GDK_INTERP_NEAREST);
    gdk_draw_pixbuf(wi->window, 0, ps, 0, 0, 0, 0, gdk_pixbuf_get_width(ps),
    gdk_pixbuf_get_height(ps), GDK_RGB_DITHER_NONE, 0, 0);
    g_object_unref(ps);
  }
  g_object_unref(p);
}


void put_statw (void) {
  btns = gtk_hbox_new(0, 0);
  PS(b1, btns);
  B("Show", uspawn, u + this_user);
  U.statw = gtk_label_new(U.stat);
  PS(btns, U.statw);
  SALL(ww);
}


gint callback (gpointer d) {
  qreplay();
  int talkk = TG(talk);
  talk_ch = (TG(send_2)) ? 2 : 1;

  if (!talkk && talk_pressed) {
    bz.m = 0;
    se(7, 0, talk_ch, 0, 0); /* send talk over */
    fprintf(stderr, "over\n");
  }
  talk_pressed = talkk;
  
  grab_avi(24000, per, talkk, TG(send_eight));
  
  if (local_frame) {
    video_out(u + 0, &bframe);
    local_frame = 0;
  }
  
  while (r()) {
    this_user = p[2];
    if (this_user <= 0) continue;
    if (1 == p[1]) { /* rep */
      /* send everything */
      bz.m = 0; if (TG(recv_a)) se(6, 0, (TG(recv_2)) ? 2 : 1,
        TG(recv_eight), TG(recv_dither)); /* send req audio */
      
      if (frame && TG(send_v)) {
        frame = 0;
        bz.m = bframe.m;
        realloc_b(bz.m, &bz);
        memcpy(bz.b, bframe.b, bframe.m);
        se(4, 0, 0, 0, 0); /* send frame */
      }
      
      bz.m = PEERS;
      int ena = TG(recv_v);
      UALL { /* ask for frames */
        bz.b[i] = (ena && (u[i].d[0] || u[i].d[1] || u[i].popup)) ? 1 : 0;
      }
      se(1, 0, 0, 0, 0); /* send req */
    }
    if (2 == p[1]) { /* stat */
      if (bz.m > 0) {
        CLAMPP(bz.m, sizeof(U.stat));
        bz.b[bz.m - 1] = 0;
        fprintf(stderr, "msg stat string '%s'\n", bz.b);
        memcpy(U.stat, bz.b, bz.m);
        if (!U.statw) put_statw();
        else gtk_label_set_text(GTK_LABEL(U.statw), U.stat);
        BOTH if (U.w[i]) TITLE(U.w[i], U.stat);
      }
    }
    if (3 == p[1]) { /* framesize */
      BOTH if (U.d[i]) DSIZE(U.d[i], rx, ry);
      U.x = rx; U.y = ry;
      U.skip = 1;
      if (p[3]) U.popup = 1;
    }
    if (4 == p[1]) { /* frame */
      if (U.skip > 0) {
        U.skip--;
        continue;
      }
      video_out(u + this_user, &bz);
    }
    if (5 == p[1]) { /* audio */
      if (rx) eight_recover(&bz);
      qaudio(0, bz.b, bz.m);
    }
    if (7 == p[1]) { /* cancel talk */
      TS(talk, 0);
      fprintf(stderr, "msg cancel talk (use interrupt button)\n");
    }
  }
  return TRUE;
}



void i_pressed (GtkWidget *w, gpointer d) {
  TS(talk, 1);
  interrupt = 1;
}

void kill_ff (GtkWidget *w, gpointer d) {
  system("/usr/bin/killall -s SIGKILL ffmpeg"); /* in case ffmpeg hangs */
  system("/usr/bin/killall avconv");
  fprintf(stderr, "\nHint: Type 'stty echo' to enable echoing\n\n"); /* in case ffmpeg steals echo */
}


void hotkey_pressed (const char *s, void *d) {
  TS(talk, !TG(talk)); /* toggle talk */
}

int hotkey (char *s, int n) {
  i = keybinder_bind(s, hotkey_pressed, 0);
  if (i) hot_num = n;
  return i;
}





int main(int argc, char *argv[]) {
  gtk_init(&argc, &argv);
  G; /* greetings */
  if (argc < 8) errx(1, "Usage:\n\n ffmpeg -hide_banner -loglevel 24 -f video4linux2"
  " -framerate 3 -video_size 160x120 -i /dev/video0 -f alsa -i default -f avi -c:v rawvideo"
  " -pix_fmt rgb24 -r:v 3 -c:a pcm_s16le -ac 1 -ar 24000 - | buffer |  ./trunk 73 1 0 1"
  " trunk_recv.pcm tcp://127.0.0.1:3345 $USER | play -q -t raw -e signed-integer"
  " -b 16 -c 1 -r 24000 -\n\n");
  per = atoi(argv[1]);
  video = atoi(argv[2]);
  sync_play = atoi(argv[3]);
  popup = atoi(argv[4]);
  af[0].fname = argv[5];
  char *endp = argv[6];
  char *username = argv[7];

  NEW(ZMQ_DEALER);
  LINGER;
  fprintf(stderr, "connecting to %s\n", endp);
  ret = zmq_connect(z, endp);
  if (ret) err(1, "zmq_connect()");

  realloc_b(BM, &bz);
  realloc_b(BM, &bv);

  bz.m = strlen(username) + 1;
  CLAMPP(bz.m, bz.s);
  memcpy(bz.b, username, bz.m);
  se(2, 0, 0, 0, 0); /* send stat */
  bz.m = 0;
  se(1, 0, 0, 0, 0); /* send req */
  
  u[0].popup = 1;
  strncpy(u[0].stat, "local", sizeof(u[0].stat));
  state1();
  int flags = fcntl(0, F_GETFL, 0);
  fcntl(0, F_SETFL, flags | O_NONBLOCK);
  flags = fcntl(1, F_GETFL, 0);
  fcntl(1, F_SETFL, flags | O_NONBLOCK);
  
  guint timer = gtk_timeout_add(per, callback, NULL);
  g_source_set_priority(g_main_context_find_source_by_id(0, timer), 150);
  
  ww = WNEW;
  g_signal_connect(ww, "delete-event", G_CALLBACK(gtk_main_quit), 0);
  b1 = gtk_vbox_new(0, 0);
  CADD(ww, b1);
  btns = gtk_hbox_new(0, 0);
  gtk_box_pack_start(GTK_BOX(b1), btns, 0 /* big */, 1, 2);
  
  keybinder_init();
  if (!hotkey("F9", 9)) hotkey("F10", 10);
  
  char snb2 [20];
  snprintf(snb2, sizeof(snb2), "(f%i)", hot_num);
  snprintf(snb, sizeof(snb), "   -=  Talk %s =-   ", (hot_num) ? snb2 : "");
  TB(snb, talk, 1);
  B("Interrupt", i_pressed, 0);
  TB("chan B", send_2, 0);
  TB("8-bit", send_eight, 0);
  TB("Send audio", send_a, 0);
  TB("Send video", send_v, 0);
  B("Kill ffmpeg", kill_ff, 0);  
  
  btns = gtk_hbox_new(0, 0);
  PS(b1, btns);
  B("Show local", uspawn, u + 0);
  TB("Recv A", recv_a, 0);
  TB("Recv V", recv_v, 0);
  TB("8-bit", recv_eight, 0);
  TB("Dither", recv_dither, 0);
  TB("chan B", recv_2, 0);
  /* TODO rewind pause */
  B("Quit", gtk_main_quit, 0);
  TS(recv_a, 1);
  TS(recv_v, 1);
  TS(send_a, 1);
  TS(send_v, 1);

  
  TITLE(ww, "TRUNK " VER);
  SALL(ww);
  
  gtk_main();
  bz.m = 0;
  se(7, 0, talk_ch, 0, 0); /* send talk over */
  i = snprintf(bz.b, bz.s, "[Quit] %s", username);
  bz.m = i + 1;
  se(2, 0, 0, 0, 0); /* send quit stat */
  zmq_close(z);
  zmq_ctx_destroy(context);
  return 0;
}

