#include <zmq.h>
#include <unistd.h>
#include <stdlib.h>
#include <err.h>
#include <string.h>
#include <arpa/inet.h>
#include <endian.h>

#define PEERS 127
#define BM 6266880

char snb [400];

int ret, i;
void *z = 0; /* zero_mq socket */
struct b_stru {char *b; int s; /* allocated size */ int m; /* message size */
} bz, bv, bframe; /* buffers */

struct peer_stru {unsigned char id [64]; int id_s; int num; long int rp [2];
  int x; int y; int popup; int newstat; int con [2]; int skip;

  struct b_stru b;
  void *d [2]; /* draw area */
  void *w [2]; /* window */
  char stat [32];
  void *statw; /* GtkLabel */
  char newsize [PEERS];
  char newframe [PEERS];
} u [PEERS], *peer = 0, *lpeer = 0;

char p [8];  /* params array */

int linger = 100;
uint16_t a16, rx, ry;
int this_user;

#define NEW(type) void *context = zmq_ctx_new(); z = zmq_socket(context, (type))
#define LINGER zmq_setsockopt(z, ZMQ_LINGER, &linger, sizeof(linger))
#define VER "v0.1"
#define G fprintf(stderr, "\n -= TRUNK =- video conferencing tool " VER "\n\n")
#define TG(a) gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON((a)))
#define TS(a, b) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON((a)), (b))
#define BOTH for (i = 0; i < 2; i++)
#define UALL for (i = 0; i < PEERS; i++)
#define U u[this_user]
#define WNEW gtk_window_new(GTK_WINDOW_TOPLEVEL)
#define DSIZE(d, x, y) gtk_drawing_area_size(GTK_DRAWING_AREA((d)), (x), (y))
#define CADD(c, w) gtk_container_add(GTK_CONTAINER((c)), (w))
#define TITLE(w, text) gtk_window_set_title(GTK_WINDOW((w)), text)
#define SALL(w) gtk_widget_show_all((w))
#define PS(a, b) gtk_box_pack_start(GTK_BOX((a)), (b), 0, 1, 2)
#define CLAMPP(a, b) if ((a) > (b)) (a) = (b)
#define CHAN(c) int chan = 0; if (2 == (c)) chan = 1
#define B(a, b, c) btn = gtk_button_new_with_label((a)); \
  g_signal_connect(G_OBJECT(btn), "clicked", G_CALLBACK((b)), (c)); PS(btns, btn)
#define TB(a, b, big) (b) = gtk_toggle_button_new_with_label((a)); \
  gtk_box_pack_start(GTK_BOX(btns), (b), (big), 1, 2)

void realloc_b (int s, struct b_stru *bu) {
  if (bu->s >= s) return;
  fprintf(stderr, "realloc_b %i\n", s);
  if (bu->b) free(bu->b);
  bu->b = malloc(s); bu->s = s; if (!bu->b) err(1, "malloc");
}


void dither (struct b_stru *bu, int enable) {
  int16_t *a = (int16_t *) bu->b; /* signed 16-bit audio input */
  char *b = bu->b;
  for (i = 0; i < bu->m / 2; i++) { /* add some noise */
    if (enable && a[i] < 32511) a[i] += (rand() & 0xff);
    b[i] = (a[i] >> 8);
  }
  bu->m = bu->m / 2; /* signed 8-bit audio on output */
}



void eight_recover (struct b_stru *bu) {
  i = bu->m;
  bu->m = i * 2;
  realloc_b(bu->m, bu);
  char *b = bu->b;
  int16_t *a = (int16_t *) bu->b;
  while (i > 0) {
    i--;
    a[i] = b[i] << 8;
  }
}


void se (char t, char pn, char ch, int x, int y) {
  if (peer) zmq_send(z, peer->id, peer->id_s, ZMQ_SNDMORE); /* zmq ROUTER peer id */

  p[0] = 1; /* version  */
  p[1] = t; /* msg type */
  p[2] = pn; /* peer num */
  p[3] = ch; /* channel */
  a16 = htons(x);
  memcpy(p + 4, &a16, 2);
  a16 = htons(y);
  memcpy(p + 6, &a16, 2);
  
  // fprintf(stderr, "sending msg_type %i, body size %i\n", p[1], bs);
  zmq_send(z, p, sizeof(p), ZMQ_SNDMORE);
  zmq_send(z, bz.b, bz.m, 0);
  memset(p, 0, sizeof(p));
}

int r (void) {
  ret = zmq_recv(z, p, sizeof(p), ZMQ_DONTWAIT); /* read params */
  if (-1 == ret) {
    if (errno != EAGAIN) perror("zmq_recv()");
    return 0;
  }
  memcpy(&a16, p + 4, 2);
  rx = ntohs(a16);
  memcpy(&a16, p + 6, 2);
  ry = ntohs(a16);
  int more;
  size_t smore = sizeof(more);
  zmq_getsockopt(z, ZMQ_RCVMORE, &more, &smore);
  bz.m = 0;
  while (more) {
    bz.m = zmq_recv(z, bz.b, bz.s, 0); /* read body (last part) */
    smore = sizeof(more);
    zmq_getsockopt(z, ZMQ_RCVMORE, &more, &smore);
  }
  if (bz.m > bz.s) bz.m = bz.s;
  return 1;
}


struct audio_s {long wp; long rp; FILE *f; char *fname; } af [2];


void qaudio (int chan, char *b, int s) {
  i = 0;
  if (!af[chan].f) {af[chan].f = fopen(af[chan].fname, "a+"); i = 1; }
  if (!af[chan].f) err(1, "fopen()");
  fseek(af[chan].f, 0, SEEK_END);
  if (i) af[chan].rp = ftell(af[chan].f); /* skip old audio */
  fwrite(b, s, 1, af[chan].f);
  af[chan].wp = ftell(af[chan].f);
}


void qreplay (void) {
  FILE *f = af[0].f;
  if (!f) return;

  i = 48000;
  while (i > 0) {
    fseek(f, af[0].rp, SEEK_SET);
    ret = fread(bz.b, 1, 16384, f);
    //fprintf(stderr, "fread() audio %i bytes\n", ret);
    if (!ret) return;
    ret = write(1, bz.b, ret); /* raw audio to stdout */
    if (ret < 0) break;
    if (ret > 0) {
      af[0].rp += ret;
      i += ret;
      //fprintf(stderr, "write() stdout %i bytes\n", ret);
    }
  }
}


void silence (int chan, int len) {
  bz.m = len * 2;
  realloc_b(bz.m, &bz);
  memset(bz.b, 0, bz.m);
  qaudio(chan, bz.b, bz.m);
}


