
#include "trunk_structs.h"

int talk [2];

void newstat_all (void) {
  UALL u[i].newstat = 1;
}


void find_id (void) {
  for (i = 1; i < PEERS; i++) {
    if (u[i].id_s) {
      if ((bz.m == u[i].id_s) && (memcmp(bz.b, u[i].id, u[i].id_s) == 0)) {
        peer = u + i; /* peer found */
        return;
      }
    } else {
      peer = u + i;
      peer->num = i;
      if (bz.m > sizeof(peer->id)) return; /* long id */
      peer->id_s = bz.m;
      memcpy(u[i].id, bz.b, bz.m);
      fprintf(stderr, "Peer #%i registered\n", peer->num);
      BOTH {
        peer->rp[i] = af[i].wp; /* skip old audio */
        if (peer->rp[i] > 96000) peer->rp[i] -= 96000; /* step back */
      }
      return;
    }
  }
  peer = 0; /* too many peers */
}


int main (int argc, char *argv[]) {
  G;
  realloc_b(BM, &bz);
  if (argc < 4) errx(1, "Usage: ./trunkd tcp://0.0.0.0:3345 001_1.pcm 001_2.pcm\n");
  af[0].fname = argv[2];
  af[1].fname = argv[3];
  silence(0, 48000); silence(1, 48000); /* 2 secs */
  NEW(ZMQ_ROUTER);
  LINGER;
  ret = zmq_bind(z, argv[1]);
  if (ret) err(2, "zmq_bind()");

  fprintf(stderr, "listening on %s\n", argv[1]);
  
  while (1) {
    ret = zmq_recv(z, bz.b, bz.s, 0); /* read ROUTER peer id */
    if (-1 == ret) err(2, "zmq_recv()");
    bz.m = ret;
    find_id();
    r(); /* read params and body */
    if (!peer) continue; /* too many peers */
    
    if (1 == p[1]) { /* req */
      /* send everything */
      char query [PEERS];
      if (bz.m > PEERS) bz.m = PEERS;
      memset(query, 0, PEERS);
      memcpy(query, bz.b, bz.m);
      UALL {
        if (u[i].id_s) {
          char siz [32], tlk [32]; int talk_c = 0;
          if (i == talk[0]) talk_c = 1;
          if (i == talk[1]) talk_c = 2;
          snprintf(siz, sizeof(siz), "(%ix%i) ", u[i].x, u[i].y);
          snprintf(tlk, sizeof(tlk), "[Talk %i] ", talk_c);
          bz.m = snprintf(bz.b, bz.s, "%s%s%s%s", (talk_c) ? tlk : "",
            (u[i].x) ? siz : "", u[i].stat, (i == peer->num) ? " (it's you)" : "");
          bz.m++;
          
          if (peer->newstat) se(2, i, 0, 0, 0); /* send stat */
          if (peer->newsize[i]) {
            peer->newsize[i] = 0;
            bz.m = 0;
            se(3, i, (peer->num == i) ? 0 : u[i].popup, u[i].x, u[i].y); /* send framesize */
          }
          if (peer->newframe[i] && u[i].b.m && query[i]) {
            peer->newframe[i] = 0;
            bz.m = u[i].b.m;
            memcpy(bz.b, u[i].b.b, bz.m);
            se(4, i, 0, 0, 0); /* send frame */
          }
        }
      }
      peer->newstat = 0;
      bz.m = 0;
      se(1, peer->num, 0, 0, 0); /* send rep */
    }
    if (2 == p[1]) { /* stat */
      newstat_all();
      CLAMPP(bz.m, sizeof(peer->stat));
      if (!bz.m) continue;
      bz.b[bz.m - 1] = 0;
      memcpy(peer->stat, bz.b, bz.m);
      fprintf(stderr, "(peer %i) stat %s\n", peer->num, bz.b);
    }
    if (3 == p[1]) { /* framesize */
      fprintf(stderr, "(peer %i) framesize %ix%i\n", peer->num, rx, ry);
      peer->popup = p[2];
      peer->x = rx;
      peer->y = ry;
      UALL u[i].newsize[peer->num] = 1;
      newstat_all();
    }
    if (4 == p[1]) { /* frame */
      // fprintf(stderr, "(peer %i) frame\n", peer->num);
      peer->b.m = bz.m;
      realloc_b(bz.m, &peer->b);
      memcpy(peer->b.b, bz.b, bz.m);
      UALL u[i].newframe[peer->num] = 1;
    }
    if (5 == p[1]) { /* audio */
      CHAN(p[3]);
      if (!talk[chan]) newstat_all();
      if ((talk[chan] && talk[chan] != peer->num) && !ry) {
        fprintf(stderr, "dropped audio %i bytes (use interrupt button)\n", bz.m);
        bz.m = 0;
        se(7, 1, 0, 0, 0); /* cancel talk */
        continue;
      }
      talk[chan] = peer->num;
      if (rx) eight_recover(&bz);
      qaudio(chan, bz.b, bz.m);
      peer->rp[chan] = af[chan].wp; /* skip my audio */
    }
    if (6 == p[1]) { /* req audio */
      CHAN(p[3]);
      if (!af[chan].f) continue;
      fseek(af[chan].f, peer->rp[chan], SEEK_SET);
      bz.m = fread(bz.b, 1, 240000, af[chan].f); /* 5 sec */
      if (!bz.m) continue;
      peer->rp[chan] += bz.m;
      if (rx) dither(&bz, ry); /* 8-bit + dither */
      se(5, 1, p[3], rx, 0); /* send audio */
    }
    if (7 == p[1]) { /* talk over */
      CHAN(p[3]);
      if (talk[chan] != peer->num) continue;
      talk[chan] = 0;
      silence(chan, 12000);
      fprintf(stderr, "talk over (peer %i) (chan %i)\n", peer->num, chan);
      newstat_all();
    }
  }
  
  
  zmq_close(z);
  zmq_ctx_destroy(context);
  return 0;
}


